require "socket"
#require "colorize"

class TED::Server

  def initialize(ip, port)
    @server = TCPServer.open(ip, port)
    @minSer = TCPServer.open(ip, port + 1)
    @minis = []
    @users = []
    @mute = Mutex.new
		log("Server ready @ #{ip}:#{port}")
		log("Listening for serverlets on #{port+1}")
    begin
    	run
    rescue Exception => e
    	puts "Shutting down!"
    end    
  end

  def run
    loop { ## Forever loop
      Thread.new(@minSer.accept) do | mini |
      	
      end
    }.join
  end
  
  def log(msg)
  	puts "[#{Time.now.strftime('%H:%M:%S')}]: #{msg}"
  end
  
  def isNameTaken(name) 
  	return false if @users.count == 0
  	@mute.synchonize do
			@users.each do |conUser|
				if conUser.name == name
					return true
				end
			end
			return false
  	end
  end
end
