class TED::Config

	def initialize(path)
		exist = File.file?(path)
		if exist
			File.open(path,"r").each do |l|
				p = l.split(",")
				@ip = p[0]
				@port = p[1].to_i
			end
			@file = File.open(path, "w+")
		else
			@file = File.open(path, "a+")
			@ip = "localhost"
			@port = 3030
			save
		end
	end
	
	def save
		@file.rewind
		@file.puts("#{@ip},#{@port}")
	end
	
	def changePort(port)
		@port=port.to_i
		save
	end
	
	def changeIP(ip)
		@ip=ip
		save
	end
	
	def getIP
		return @ip
	end
	
	def getPort
		return @port.to_i
	end
	
	def close
		save
		@file.close
	end
end
