require "socket"

class TED::Serverlet

	def initialize(ip="localhost", port=9017)
		@hub = TCPSocket.open("46.101.76.160", 9018)
		@server = TCPServer.open(ip, port)
		@resp = nil
		@game = nil
		run
		@resp.join
	end
	
	def run
		@resp = Thread.new do ## Handle all the messages coming in from the hub and act appropriatly
			loop{
				msg = @hub.gets.chomp
				puts msg
			}
		end
		
		Thread.new(@server.accept) do |client|
			client.puts "Connected!"
		end
	end
	
end
